QGIS Application - Bug report #15743
Processing: errors in underlying commands are not handled gracefully by iterations
2016-10-22 09:38 AM - Paolo Cavallini

Status: Closed

Priority: Severe/Regression

Assignee: Victor Olaya

Category: Processing/Core

Affected QGIS version:2.16.3 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 23665
Description

When a command has an error, and is ran as iterative, the underlying error is not handled gracefully, and returns:

Traceback (most recent call last):

File "/usr/share/qgis/python/plugins/processing/gui/AlgorithmDialog.py", line 238, in accept
if runalglterating(self.alg, self.iterateParam, self):

File "/usr/share/qgis/python/plugins/processing/gui/AlgorithmExecutor.py", line 90, in runalglterating
if runalg(alg):

File "/usr/share/qgis/python/plugins/processing/gui/AlgorithmExecutor.py", line 52, in runalg
progress.error(e.msg)

AttributeError: '"NoneType' object has no attribute 'error’

See example in:

https://github.com/qgis/QGIS-Training-Data/tree/master/training_manual data/processing/iterative

History

#1 - 2016-10-22 09:49 AM - Victor Olaya

this is fixed in master

#b4562d143e6ef140e14b0cb9625ef923412db793

Looks like it is not backported...

#2 - 2016-10-22 10:03 AM - Paolo Cavallini

Thanks. IMHO it is useful to backport it both to 2.14 and to 2.16 series.

#3 - 2016-10-22 11:10 PM - Paolo Cavallini
- Priority changed from Normal to High

Unsure whether it is the same error. Also running "SAGA:Clip raster with polygon® runs fine without iterative, but fails when iterating, with:

Traceback (most recent call last):
https://github.com/qgis/QGIS-Training-Data/tree/master/training_manual_data/processing/iterative

File "/usr/share/qgis/python/plugins/processing/gui/AlgorithmDialog.py", line 238, in accept
if runalglterating(self.alg, self.iterateParam, self):

File "/usr/share/qgis/python/plugins/processing/gui/AlgorithmExecutor.py”, line 90, in runalglterating
if runalg(alg):

File "/usr/share/qgis/python/plugins/processing/gui/AlgorithmExecutor.py”, line 52, in runalg
progress.error(e.msg)

AttributeError: 'NoneType' object has no attribute ‘error’

#4 - 2016-10-22 11:23 PM - Paolo Cavallini

- Priority changed from High to Severe/Regression

AFAICT iterating is broken now in 2.16, so | raise the severity.

#5 - 2016-10-24 07:05 AM - Paolo Cavallini

in 2.18, no error is displayed, even when layers are not created.

#6 - 2016-10-25 03:41 AM - Alexander Bruy

If I understand correctly 2.16 will not receive updates anymore, so there is no sense to backport anything to it

#7 - 2016-10-25 05:26 AM - Paolo Cavallini
- Status changed from Open to Closed

Agreed.
